require 'sketchup.rb'
require 'extensions.rb'

module Ladb
  module OpenCutList

    require 'sketchup.rb'
    require 'extensions.rb'
    require_relative 'af_Custom/ladb_opencutlist/ruby/constants.rb'

    unless file_loaded?(__FILE__)

      # Create extension
      ex = SketchupExtension.new(EXTENSION_NAME, 'af_Custom/ladb_opencutlist/ruby/main')
      ex.version     = EXTENSION_VERSION
      ex.copyright   = '2016-2019 - GNU GPLv3'
      ex.creator     = 'L\'Air du Bois - www.lairdubois.fr'

      # Localize description
      case Sketchup.get_locale.split('-')[0].downcase
      when 'fr'
        ex.description = 'Générateur de fiche de débit et calepinage de panneaux pour les boiseux. Open Source et facile à utiliser ;)'
      when 'de'
        ex.description = 'Holzlistengenerator für Tischler/Schreiner. Open Source und einfach anzuwenden ;)'
      else
        ex.description = 'Cutlist and Cutting Diagram Generator for Woodworkers. Open Source and Easy to Use ;)'
      end

      # Register extension
      Sketchup.register_extension(ex, true)
      file_loaded(__FILE__)

    end

  end
end

##########################################################################
def af_Custom(string="",file=nil)
  string=string.to_s
  unless file && FileTest.exist?(file)
    return string
  else ### it's perhaps translated
    IO.readlines(file).each{|line|
	  next if line =~ /^[#]/
      line.chomp! ### loose \n off end
      if line =~ /[<][=][=][>]/
        set = line.split("<==>")
        if set[0] == string
					string = set[1]
					break
				end
      end#if
    }
    return string
  end#if
end#def

module AF
  module Custom


require 'langhandler.rb'
	$SteveR_toComponentsStrings=LanguageHandler.new("SteveR_tocomponents.strings")
   	ext = SketchupExtension.new $SteveR_toComponentsStrings.GetString("SteveR-to Components"), "af_Custom/SteveR_tocomponents/SteveR_tocomponents_menu.rb"
   	Sketchup.register_extension ext, true


    VERSION = "6.5/LAOYAO"
    PLUGIN_NAME = "TC-定制助手"

    if Sketchup.version.to_i >= 16
      btExtension = SketchupExtension.new(PLUGIN_NAME, (File.join(File.dirname(__FILE__),"af_custom","bt_load")))
      btExtension.description = ("用不板式家具定制设计！适用于win..系统su2019+")
      btExtension.version = VERSION
      btExtension.creator = ""
      btExtension.copyright = ""
      Sketchup.register_extension(btExtension, true)
     else
       UI.messagebox("你需要安装SketchUp 2019或更高版本。")
     end

  end
end