require 'sketchup.rb'
module DM
module ProfileBuilder2
class FenceBuilderTool
include WebDialogHelper
include Geometry
private_class_method :new 
@@fence_builder_tool=nil
def FenceBuilderTool.create
	@@fence_builder_tool=new unless @@fence_builder_tool
	return @@fence_builder_tool
end
def FenceBuilderTool.close()
if @@fence_builder_tool
	@@fence_builder_tool.close()
	@@fence_builder_tool=nil
end
end
###
def initialize
if ON_MAC
	@dlg=UI::WebDialog.new("家居定制版-构件放样", false, "PB2Assembler",310,800,150,150,false)
else
	@dlg=UI::WebDialog.new("家居定制版-构件放样", false, "PB2Assembler",340,840,100,100,true)
end
@dlg.set_file(File.join(PATH,"fencebuilder.html"))
color = @dlg.get_default_dialog_color 
@dlg.set_background_color(color)
@dlg.set_on_close {clean_up()}
@dict="PBFence"
@fence=Fence.new
@selected_post_index=0
@selected_rail_index=0
@selected_fences=[]
#TODO - ensure that only one instance of the observer can be added
@selection_observer=SelectionObserver.new {set_selection_status()}
Sketchup.active_model.selection.add_observer(@selection_observer)
@model_observer=ModelObserver.new {validate_edit_path()}
Sketchup.active_model.add_observer(@model_observer)
last_fence=ProfileBuilder2.get_last_assembly_path()
@dlg.add_action_callback("ValueChanged") {|d,p|
	
	pair=p.split("|")
	id=pair[0]
	value=pair[1]
	length=Sketchup.parse_length(value) if value
	post=@fence.post_at(@selected_post_index)
	rail=@fence.rail_at(@selected_rail_index)
	case id
		when "SaveFencebutton"
			save_fence()
		when "LoadFencebutton"
			browseFence()
		when "NewFenceButton"
			@fence=Fence.new
			@selected_post_index=0
			@selected_rail_index=0
			refresh_tables()
		when "BuildFenceButton"
			Sketchup.active_model.select_tool(DynamicFenceTool.new(@fence))
		when "BuildAlongPathButton"
			pts=validate_build_fence_input()
			build_fence(pts) if pts
		when "EditPathbutton"
			e=Sketchup.active_model.active_path.last
			if Classify.assembly?(e)
				defn=e.definition
				a=Assembly.get(defn)
				a.edit_path(e)
			else
				UI.messagebox("请选择一个组件.")
			end
		when "ApplyButton"
			selected_fences=get_selected_fences()
			if selected_fences.first
				Sketchup.active_model.start_operation("Edit Fence",true)
				selected_fences.each {|e|
					e.make_unique if e.kind_of?(Sketchup::Group) 
					a=Assembly.get(e)
					a.fence=@fence
					a.draw()
				}
				Sketchup.active_model.commit_operation
			end
		when "fenceName"
			@fence.name=value
		when "fenceDescription"
			@fence.description=value
		when "PickFencebutton"
			Sketchup.active_model.select_tool(AssemblyPickerTool.new {|inst| load_fence_from_instance(inst);refresh_tables();refresh_thumbnail();})
		when "railProfile"
			Sketchup.active_model.select_tool(ProfileMemberPickerTool.new {|pm| rail.profile=pm.profile;rail.profile.set_from_profile_member(pm);refresh_profile();refresh_thumbnail();})
		when "editProfile"
			ProfileBuilderTool.create_modal.show_modal(rail.profile) {|profile| load_profile(rail,profile) }
		when "postComp"
			Sketchup.active_model.select_tool(ComponentPickerTool.new {|inst| load_component(post,inst)})
		when "addPostButton"
			@fence.add_post()
			@selected_post_index=@fence.count_posts-1
			refresh_tables()
		when "deletePostButton"
			@fence.delete_post_at(@selected_post_index)
			@selected_post_index=@selected_post_index-1
			refresh_tables()
		when "previousPostButton"
			@selected_post_index-=1
			@selected_post_index=@fence.count_posts-1 if @selected_post_index<0
			refresh_tables()
		when "nextPostButton"
			@selected_post_index+=1
			@selected_post_index=0 if @selected_post_index==(@fence.count_posts)
			refresh_tables()
		when "postName"
			post.name=value
		when "postSpacing"
			post.spacing=length
		when "postMaxSpacing"
			post.max_spacing=value
		when "postHorizontalSpacing"
			post.horizontal_spacing=value
		when "postLayout"
			post.layout=value
		when "startCheckbox"
			post.at_start=value
			setVisibility()
		when "junctionCheckbox"
			post.at_junction=value
		when "endCheckbox"
			post.at_end=value
		when "infillCheckbox"
			post.at_infill=value
			refresh_tables()
		when "postJunctionAngle"
			post.junction_angle=length
		when "postRotation"
			post.rotation=value
		when "postStayVertical"
			post.stay_vertical=value
		when "postMirror"
			post.mirror=value
		when "postHeightOffset"
			post.global_z_offset=length
		when "postXOffset"
			post.x_offset=length
		when "postYOffset"
			post.y_offset=length
		when "postZOffset"
			post.z_offset=length
		when "postStartSetback"
			post.start_setback=length
		when "postJunctionSetback"
			post.junction_setback=length
		when "postEndSetback"
			post.end_setback=length
		when "postJunctionAngle"
			post.junction_angle=value.to_f
		####################################
		when "addRailButton"
			@fence.add_rail()
			@selected_rail_index=@fence.count_rails-1
			refresh_tables()
		when "deleteRailButton"
			@fence.delete_rail_at(@selected_rail_index)
			@selected_rail_index=@selected_rail_index-1
			refresh_tables()
		when "previousRailButton"
			@selected_rail_index-=1
			@selected_rail_index=@fence.count_rails-1 if @selected_rail_index<0
			refresh_tables()
		when "nextRailButton"
			@selected_rail_index+=1
			@selected_rail_index=0 if @selected_rail_index==(@fence.count_rails)
			refresh_tables()	
		when "railName"
			rail.name=value	
		when "railHeightOffset"
			rail.global_z_offset=length
		when "railXOffset"
			rail.x_offset=length
		when "railYOffset"
			rail.y_offset=length
		when "railZOffset"
			rail.z_offset=length
		when "railStartSetback"
			rail.start_setback=length
		when "railJunctionSetback"
			rail.junction_setback=length
		when "railEndSetback"
			rail.end_setback=length
		when "railStartSetback"
			rail.start_setback=length
		when "railEndSetback"
			rail.end_setback=length
		
	end
	case id
		when "BuildFenceButton","BuildAlongPathButton","ApplyButton","fenceName","fenceDescription","fenceDescription","EditPathbutton","ApplyButton","railProfile","nextRailButton","previousRailButton","previousPostButton","nextPostButton","addPostButton","addRailButton"
			#
		else
			refresh_thumbnail()
	end
	
} #valuechanged
@dlg.add_action_callback("setCurrentTab") {|d,p|
	@current_tab_index=p.to_i
	set_dialog_height()
}
@dlg.add_action_callback("RefreshValues") {|d,p|
	refresh_tables()
	refresh_thumbnail()
}

@dlg.add_action_callback("setHeight") {|d,p|
	#height=p.to_i
	#d.set_size(340,height)
}
end  #end initialize
def show
#skp="C:\\Users\\Dale\\Dropbox\\Plugins\\Profile Builder\\Profile Bulider Pro\\Version 2.0\\Assemblies\\Test.skp"
#@dlg.show{load_fence_from_skp(skp)}
if ON_MAC == true
	@dlg.show_modal{refresh_tables();refresh_thumbnail();} unless @dlg.visible?
else
	@dlg.show{refresh_tables();refresh_thumbnail();} unless @dlg.visible?
end

end
##
def close()
@dlg.close()
end
##
def clean_up()
@browser.close if @browser
end
##
def browseFence()
@browser.close if @browser
last_path=ProfileBuilder2.get_last_assembly_path()
if FileTest.exist?(last_path)
	folder=File.dirname(last_path)
else
	folder=File.join(File.dirname(__FILE__),"Libraries","Assembly Examples")
	if !FileTest.exist?(folder)
		folder=Dir.pwd
	end
end
@browser=SKPBrowser.new(folder,"Select Assembly") {|skp|
	status=load_fence_from_skp(skp)
	if status
		refresh_thumbnail()
		@browser.close
		ProfileBuilder2.save_last_assembly_path(skp)
		@dlg.bring_to_front
	else
		UI.messagebox("选择的组件不是一个有效的组件放样集，不能被加载。")
	end
}
@browser.show
end
##
def get_selected_fences()
selected=[]
Sketchup.active_model.selection.each {|e|
	if Classify.assembly?(e)
		selected.push(e)
	end
}
return selected
end
##
def load_component(post,inst)
post.component_name=inst.definition.name
post.layer_name=inst.layer.name
refresh_component()
refresh_thumbnail()
end
##
def load_profile(rail,profile)
rail.profile=profile
refresh_profile()
refresh_thumbnail()
end
##
def set_dialog_height()
cmd="setHeight();"
@dlg.execute_script(cmd)
end
###
def build_prototype(name="Assembly")
model=Sketchup.active_model
defns=model.definitions
su_fence_defn=defns.add(name)
if su_fence_defn
	fence_ents=su_fence_defn.entities
	num_posts=@fence.count_posts
	if num_posts>0
		posts=@fence.posts
		post_spacings=posts.collect {|post| post.spacing}
		post_defns=posts.collect {|post| post.component_definition}
		post_defns.delete(nil)
		post_heights=post_defns.collect {|defn| defn.bounds.depth}
		max_post_height=post_heights.max
		max_spacing=post_spacings.max 
		max_post_height=max_spacing unless max_post_height
		fence_length=[max_spacing*2,max_post_height].max
	else
		fence_length=48.0
	end
	p0=Geom::Point3d.new(0,0,0)
	p1=Geom::Point3d.new(fence_length,0,0)
	chain=Chain.new([p0,p1])
	a=Assembly.create_in(su_fence_defn)
	a.fence=@fence
	a.set_chain(chain)
	a.draw()	
end
return su_fence_defn
end
##
def save_fence_thumbnail(su_fence_defn)
path=Sketchup.temp_dir
filename="assembly.bmp"
path=File.join(path,filename)
status=su_fence_defn.save_thumbnail(path)
if status
	@preview_path=path
else
	@preview_path=nil
end
end
#
def refresh_tables()
set_selection_status()
set_post_and_rail_indices()
setValue("fenceName",@fence.name)
setValue("fenceDescription",@fence.description)
post=@fence.post_at(@selected_post_index)
if post!=nil
	if post.name==""
		setValue("postName","Component##{@selected_post_index+1}")
	else
		setValue("postName",post.name)
	end
	refresh_component()
	setCheckbox("infillCheckbox",post.at_infill)
	setCheckbox("startCheckbox",post.at_start)
	setCheckbox("endCheckbox",post.at_end)
	setCheckbox("junctionCheckbox",post.at_junction)
	setValue("postStartSetback",format_length(post.start_setback))
	setValue("postJunctionSetback",format_length(post.junction_setback))
	setValue("postEndSetback",format_length(post.end_setback))
	setValue("postSpacing",format_length(post.spacing))
	setCheckbox("postMaxSpacing",post.max_spacing)
	setCheckbox("postHorizontalSpacing",post.horizontal_spacing)
	setValue("postLayout",post.layout)
	setValue("postHeightOffset",format_length(post.global_z_offset))
	setValue("postXOffset",format_length(post.x_offset))
	setValue("postYOffset",format_length(post.y_offset))
	setValue("postRotation",post.rotation)
	setValue("postJunctionAngle",post.junction_angle)
	setCheckbox("postStayVertical",post.stay_vertical)
	setCheckbox("postMirror",post.mirror)
end
setVisibility()
rail=@fence.rail_at(@selected_rail_index)
if rail!=nil
	if rail.name==""
		setValue("railName","Profile##{@selected_rail_index+1}")
	else
		setValue("railName",rail.name)
	end
	refresh_profile()
	setValue("railHeightOffset",format_length(rail.global_z_offset))
	setValue("railXOffset",format_length(rail.x_offset))
	setValue("railYOffset",format_length(rail.y_offset))
	setCheckbox("railAllowSlope",rail.allow_slope)
	setValue("railStartSetback",format_length(rail.start_setback))
	setValue("railEndSetback",format_length(rail.end_setback))
end
end
##
def refresh_thumbnail()
Sketchup.active_model.start_operation("Build Prototype",true)
defn=build_prototype()
save_fence_thumbnail(defn)
Sketchup.active_model.abort_operation
if @preview_path
	cmd="$('#PreviewImage').attr('src','file:\/\/#{@preview_path}?#{(rand*10000).to_i}')"  #adding random data ensures the image is not loaded from the cache
	@dlg.execute_script(cmd)
end
end
##
def hide_post_settings()
cmd="hidePostSettings();"
@dlg.execute_script(cmd)
end
def show_post_settings()
cmd="showPostSettings();"
@dlg.execute_script(cmd)
end
##
def hide_rail_settings()
cmd="hideRailSettings();"
@dlg.execute_script(cmd)
end
##
def show_rail_settings()
cmd="showRailSettings();"
@dlg.execute_script(cmd)
end
##
def setVisibility()
post=@fence.post_at(@selected_post_index)
if post!=nil
	if post.at_infill=="true"
		cmd="activateInfill();"
		@dlg.execute_script(cmd)
	else
		cmd="deactivateInfill();"
		@dlg.execute_script(cmd)
	end
end
num_posts=@fence.count_posts
num_rails=@fence.count_rails
if num_posts==0
	hide_post_settings()
else
	show_post_settings()
end
if num_rails==0
	hide_rail_settings()
else	
	show_rail_settings()
end
end
##
def set_post_and_rail_indices()
num_posts=@fence.count_posts
num_rails=@fence.count_rails
if num_posts>0
	text="#{@selected_post_index+1} of #{num_posts}"
else
	text=""
end
setText("postIndex",text)
if num_rails>0
	text="#{@selected_rail_index+1} of #{num_rails}"
else
	text=""
end
setText("railIndex",text)
end

##
def refresh_component()
post=@fence.post_at(@selected_post_index)
component_name=post.component_name
if (component_name!="") and (post.valid?)
	setValue("postComp",component_name)
else
	setValue("postComp","从模型中拾取..")
end
end
##
def refresh_profile()
rail=@fence.rail_at(@selected_rail_index)
if rail
	profile=rail.profile
	if profile!=nil 
		setValue("railProfile",profile.name)
	else
		setValue("railProfile","从模型中拾取..")
	end
end
end
##
def set_selection_status()
sel=Sketchup.active_model.selection
assemblies=sel.find_all {|e| Classify.assembly?(e)}
num_selected=assemblies.length
case num_selected
	when 0
		cmd="$('#ApplyButton').button('disable');"
		text="No Assemblies Selected"
	when 1
		cmd="$('#ApplyButton').button('enable');"
		text="#{num_selected} Assembly Selected"
	else
		cmd="$('#ApplyButton').button('enable');"
		text="#{num_selected} Assemblies Selected"
end
@dlg.execute_script(cmd)
end
##
def validate_edit_path()
a_path=Sketchup.active_model.active_path
if a_path
	e=Sketchup.active_model.active_path.last
	if Classify.assembly?(e)
		cmd="$('#EditPathbutton').button('enable');"
	else
		cmd="$('#EditPathbutton').button('disable');"
	end
else
	cmd="$('#EditPathbutton').button('disable');"
end
@dlg.execute_script(cmd)
end
##
def format_length(length)
result=Sketchup.format_length(length).gsub(/"/,"\\\"")
return result
end
def setValue(id,value)
	new_value=value.to_s
	cmd="document.getElementById('#{id}').value=\"#{new_value}\""
	@dlg.execute_script(cmd)
end
def setCheckbox(id,checked)
	checked=checked.to_s  #can take either a true or false parameter as a string or TrueClass/FalseClass
	cmd="document.getElementById('#{id}').checked=#{checked}"
	@dlg.execute_script(cmd)
end
def setText(id,text)
	cmd="document.getElementById('#{id}').innerHTML=\"#{text}\""
	@dlg.execute_script(cmd)
end
##
def load_fence_from_instance(e)
if Classify.assembly?(e)
	fence_group=e
	su_defn=e.definition
	@fence=Fence.new
	@fence.load_from_defn(su_defn)
end
end
##
def load_fence_from_skp(skp)
defns=Sketchup.active_model.definitions
Sketchup.active_model.start_operation("Load Assembly",true)
fence_defn=defns.load(skp)
unless Classify.assembly?(fence_defn)
	Sketchup.active_model.abort_operation
	return false
end
@fence=Fence.new
@fence.load_from_defn(fence_defn)
refresh_tables()
return true
end
#save the fence
def save_fence()
last_path=ProfileBuilder2.get_last_assembly_path()
if FileTest.exist?(last_path)
	folder=File.dirname(last_path)
else
	folder=Dir.pwd
end
skp=UI.savepanel("保存组件合集",folder,@fence.filename+".skp")
return if not skp
begin
	model=Sketchup.active_model
	fence_name=File.basename(skp,".*")
	model.start_operation("Save Fence",true,true,false)
	su_fence_defn=build_prototype(fence_name)
	skp_path=File.join(File.dirname(skp),fence_name+".skp")
	status=su_fence_defn.save_as(skp_path)
	ProfileBuilder2.save_last_assembly_path(skp_path)
rescue
	UI.messagebox("保存出错.")
	raise
end
model.abort_operation
UI.messagebox("保存成功.")
end #save fence
##
def build_fence(pts)
Sketchup.active_model.start_operation("Build Fence",true)
ents=Sketchup.active_model.active_entities
a=Assembly.add(ents)
a.fence=@fence
a.set_chain(Chain.new(pts))
a.draw()
Sketchup.active_model.commit_operation
end

#checks the current selection and fence builder input table for valid input
def validate_build_fence_input()
sel=Sketchup.active_model.selection
if sel.empty?
	UI.messagebox("请至少选择一条线.")
	return false
end
#todo validate FenceBuilder Input
edges=sel.find_all {|e| e.class==Sketchup::Edge}
if edges.length==0
	if sel.first.class==Sketchup::Face
		edges=sel.first.edges
	end
end
if edges.length==0  #no edges were found
	UI.messagebox("请至少选择一条线或者一个单一的面.")
	return false
else
	path=PathSelectTool.get_selected_path()
	unless path
		result=UI.messagebox("未找到有效的路径.")
		return false
	else
		return path
	end
end
return false
										
end  #validate_build_fence_input
end #class 
#base class for fence members
class FenceElement
attr_reader :name, :global_z_offset, :x_offset, :y_offset, :z_offset, :start_setback, :junction_setback, :end_setback
attr_writer :name, :global_z_offset, :x_offset, :y_offset, :z_offset, :start_setback, :junction_setback, :end_setback
def initialize(object=nil)
	@name=""
	@global_z_offset=0.0
	@x_offset=0.0
	@y_offset=0.0
	@start_setback=0.0
	@junction_setback=0.0
	@end_setback=0.0
end #initialize
end  #end class 
class Post < FenceElement
attr_reader :instances, :spacing, :layout, :at_start, :at_junction, :at_end, :at_infill, :junction_angle, :rotation, :stay_vertical, :mirror, :max_spacing, :horizontal_spacing, :layer_name, :component_defn_guid
attr_writer :spacing, :layout, :at_start, :at_junction, :at_end, :at_infill, :junction_angle, :rotation, :stay_vertical, :mirror, :max_spacing, :horizontal_spacing, :layer_name
def initialize(object=nil)
	super
	@component_name=""
	@component_defn_guid=nil
	@spacing=96.0
	@layout="From Start"
	@at_start="false"
	@at_junction="false"
	@at_end="false"
	@at_infill="true"
	@junction_angle=60.0
	@rotation="0"
	@stay_vertical="true"
	@mirror="false"
	@max_spacing="true"
	@horizontal_spacing="true"
	@layer_name=Sketchup.active_model.layers[0].name
	@instances={}
	
	if object.class==String
		load_from_string(object)
	end
	
end
def valid?
valid=true
valid=false if self.component_definition==nil
valid=false if @spacing<=0.0
return valid
end
def clear_instances()
@instances={}
end
def add_instance(trans,edge)
unless @instances[edge]
	@instances[edge]=[]
end
@instances[edge].push(trans)
	
end
def component_name
defn=self.component_definition
if defn
	name=defn.name
else
	name=nil
end
return name
end
def component_name=(value)
@component_name=value
definition_list=Sketchup.active_model.definitions
defn=definition_list[value]
@component_defn_guid=defn.guid
end
def component_definition
definition_list=Sketchup.active_model.definitions
defn=definition_list[@component_name]
if defn==nil and @component_defn_guid
	defn=definition_list[@component_defn_guid]
	@component_name=defn.name if defn
end
return defn
end
def horizontal_layout?
result=@horizontal_spacing=="true" ? true : false
return result
end
def fixed_spacing?
result=@max_spacing=="true" ? false : true
return result
end
def stay_vertical?
result=@stay_vertical=="true" ? true : false
return result
end
def mirror?
result=@mirror=="true" ? true : false
return result
end
#
def load_from_string(string)
arr=string.split("|")
@name=arr[0]
@spacing=arr[2].to_f
@layout=arr[3]
@at_start=arr[4]
@at_junction=arr[5]
@at_end=arr[6]
@at_infill=arr[7]
@x_offset=arr[8].to_f
@y_offset=arr[9].to_f
@start_setback=arr[10].to_f
@junction_setback=arr[11].to_f
@end_setback=arr[12].to_f
@rotation=arr[13]
@stay_vertical=arr[14]
@mirror=arr[15]
@global_z_offset=arr[16].to_f
guid=arr[17]
@layer_name=arr[18].to_s
@junction_angle=arr[19].to_f
@max_spacing=arr[20]
@horizontal_spacing=arr[21]
if guid
	defns=Sketchup.active_model.definitions
	defn=defns[guid]
	if defn
		self.component_name=defn.name
	else
		self.component_name=arr[1]
	end
else
	self.component_name=arr[1]
end
end #load properties
#
def to_s
defn=self.component_definition
guid=defn ? defn.guid : ""
arr=[@name,@component_name,@spacing,@layout,@at_start,@at_junction,@at_end,@at_infill,@x_offset,@y_offset,@start_setback,@junction_setback,@end_setback, @rotation,@stay_vertical,@mirror,@global_z_offset,guid,@layer_name, @junction_angle, @max_spacing,@horizontal_spacing]
return arr.join("|")

end #to_s
def at_start?
result=@at_start=="true" ? true : false
return result
end
def at_end?
  result=@at_end=="true" ? true : false
  return result
end
def at_junction?
  result=@at_junction=="true" ? true : false
  return result
end
def at_infill?
	result=@at_infill=="true" ? true : false
	return result
end
end #class post
####class for fence rail
class Rail < FenceElement
attr_reader :profile, :allow_slope
attr_writer :profile, :allow_slope
def initialize(object=nil)
	@profile=nil
	@allow_slope="true"
	super
	if object.class==String
		load_from_string(object)
	end
end
#populates the attributes of the rail from the string
def load_from_string(string)
arr=string.split(";")
@name=arr[0]
@profile=Profile.new(arr[1])
@x_offset=arr[2].to_f
@y_offset=arr[3].to_f
@z_offset=arr[4].to_f
@start_setback=arr[5].to_f
@junction_setback=arr[6].to_f
@end_setback=arr[7].to_f
@allow_slope=arr[8]=="true" ? true : false
@global_z_offset=arr[9].to_f

end #load properties
##
def valid?
v=true
if @profile==nil or @profile==""
	v=false
end
return v
end
#
def to_s
arr=[@name,@profile,@x_offset,@y_offset,@z_offset,@start_setback,@junction_setback,@end_setback,@allow_slope,@global_z_offset]
return arr.join(";")
end #to_s
##
def offset_chain(chain)
#calculate the offset profile location
y_offset=self.y_offset
x_offset=self.x_offset
if y_offset!=0.0 or x_offset!=0.0
	chain.offset!(x_offset,y_offset)
end
global_z_offset=self.global_z_offset
if global_z_offset!=0.0
	chain.offset_global_z!(global_z_offset)
end
return chain
end
end #class rail
##Fence Class
class Fence
attr_reader :description, :posts, :rails, :infill, :name, :chain
attr_writer :description
def initialize
@posts=[]
@rails=[]
@segments=[]  #an array of Curve(s)
@chain=nil
self.name="请载入构件..."
@description="添加说明..."
@dict="PBFence"
end #init
def name=(value)
#@name=Sketchup.active_model.definitions.unique_name(value)
@name=(value)
return value
end
def filename
illegal="\\\/:*?\"<>|"
return @name.delete(illegal)
end
def add_post(post=Post.new)
  @posts.push(post)
end
def set_post(post,index)
  @posts[index]=post
end
def post_at(index)
  @posts[index]
end
def add_rail(rail=Rail.new)
  @rails.push(rail)
end
def set_rail(rail,index)
  @rails[index]=rail
end
def rail_at(index)
  @rails[index]
end
def count_posts()
  @posts.length
end
def count_rails()
  @rails.length
end
def delete_post_at(index)
  @posts.delete_at(index)
end
def delete_rail_at(index)
  @rails.delete_at(index)
end
#
def calculate_segments(angle)
junctions=calculate_junction_indices(angle)
segments=create_segments(junctions)
return segments
end
#returns the indicies of the junction points
def calculate_junction_indices(angle)
path=chain.path
junctions=[]
num_pts=path.length
(num_pts-2).times {|i|
	v1=path[i].vector_to(path[i+1])  #find the vector of the two points
	v2=path[i+1].vector_to(path[i+2])  #find the vector of the next two points
	#if the angle is larger than the critical junction angle, cache the index
	if (v1.angle_between(v2)).abs>angle
		junctions.push(i+1)  
	end
}
junctions.push(path.length-1)
return junctions
end
#creates a group and a series of curves (segments)
def create_segments(junctions)
path=@chain.path
pt_index=0
segments=[]
junctions.each{|junction_index|
	curve_pts=path[pt_index..junction_index]
	segments.push(Curve.new(curve_pts))
	pt_index=junction_index
}
return segments
end
#
def calc_posts_layout(pts)
begin
	@chain=Chain.new
	@chain.set_path(pts)
	@posts.each {|post|	calc_post_layout(post) if post.valid?}
rescue
	@posts.each {|post|	post.clear_instances if post.valid?}
	@chain=nil
	raise
end
end
##
def calc_post_layout(post)
segments=calculate_segments(post.junction_angle.degrees)
post.clear_instances
segments.each {|curve| 
	
	curve_length=curve.length
		
	is_first_segment=(curve==segments.first)
	is_last_segment=(curve==segments.last)
	
	if post.at_infill?
	
		if post.horizontal_layout?
			curve_length=curve.flattened_length
		end
		
		first_infill_post_location=get_first_infill_post_location(post,curve,is_first_segment)
		last_infill_post_location=get_last_infill_post_location(post,curve,is_last_segment)
		
		next if first_infill_post_location==nil or last_infill_post_location==nil
		next if first_infill_post_location>last_infill_post_location
		
		if post.layout=="From Start" or !post.fixed_spacing?
			add_post_on_curve(post,curve,first_infill_post_location)
		end
		
		if post.layout=="From Start" or !post.fixed_spacing?
			if not is_last_segment
				unless post.junction_setback==0.0  #prevents duplicate posts at junctions
					add_post_on_curve(post,curve,last_infill_post_location) unless post.fixed_spacing?
				end
			else
				unless post.end_setback==0.0 and post.start_setback==0.0 and @chain.closed_path?
					add_post_on_curve(post,curve,last_infill_post_location) unless post.fixed_spacing?
				end
			end
		end
		
		spacing=post.spacing
		if post.fixed_spacing?
			infill_distance=(last_infill_post_location-first_infill_post_location)
			if post.layout=="From Middle"
				mid_post_location=(last_infill_post_location+first_infill_post_location)/2.0
				num_gaps=(((mid_post_location-first_infill_post_location)/spacing).ceil)*2
				location=mid_post_location-(spacing*(num_gaps)/2.0)
			else
				num_gaps=(infill_distance/spacing).ceil
				location=first_infill_post_location
			end
			gap_distance=spacing
			num_posts=num_gaps-1
			
		else
			infill_distance=(last_infill_post_location-first_infill_post_location)
			if post.layout=="From Middle"
				mid_post_location=infill_distance/2.0
				num_gaps=(((mid_post_location-first_infill_post_location)/spacing).ceil)*2
			else
				num_gaps=(infill_distance/spacing).ceil
			end
			gap_distance=infill_distance/num_gaps.to_f
			num_posts=num_gaps-1
			location=first_infill_post_location
		end
		
		#add infill posts if we have enough curve length
		if post.spacing<infill_distance
			num_posts.times{|i|
				location+=gap_distance
				add_post_on_curve(post,curve,location)
			}
		end
		
	else
		
		unless @chain.closed_path?
			if is_first_segment and post.at_start?
				add_post_on_curve(post,curve,post.start_setback)
			end
			
			if is_last_segment and post.at_end?
				add_post_on_curve(post,curve,curve_length-post.end_setback) 
			end
		end
		
		if post.at_junction?
			add_post_on_curve(post,curve,curve_length-post.junction_setback) unless is_last_segment
			unless post.junction_setback==0.0  #prevents duplicate posts
				add_post_on_curve(post,curve,post.junction_setback) unless is_first_segment
			end
		end
		
	end #if post at infill
			
}

end
#####
def get_first_infill_post_location(post,curve,is_first_segment=false)
if post.horizontal_layout?
	curve_length=curve.flattened_length
else
	curve_length=curve.length
end
start_setback=is_first_segment ? post.start_setback : post.junction_setback
if curve_length<start_setback
	location=nil
else
	location=start_setback
end
return location
end
#####
def get_last_infill_post_location(post,curve,is_last_segment=false)
if post.horizontal_layout?
	curve_length=curve.flattened_length
else
	curve_length=curve.length
end
end_setback=is_last_segment ? post.end_setback : post.junction_setback
if curve_length<end_setback
	location=nil
else
	location=curve_length-end_setback
end
return location
end
#
def add_post_on_curve(post,curve,distance_from_curve_start)
trans_edge=get_post_location_on_curve(post,curve,distance_from_curve_start)
post_transformation=trans_edge[0]
edge=trans_edge[1]
post_location=post_transformation.origin
x_axis=post_transformation.xaxis
y_axis=post_transformation.yaxis
z_axis=post_transformation.zaxis
#offset the post location according to the input offsets
offsets=[post.x_offset,post.y_offset]
x_offset=x_axis.clone
x_offset.length=offsets[0]
y_offset=y_axis.clone
y_offset.length=offsets[1]
global_z_offset=Z_AXIS.clone
global_z_offset.length=post.global_z_offset
total_offset=x_offset+y_offset+global_z_offset
post_location=post_location.offset(total_offset)
if post.stay_vertical?
	if x_axis.parallel?(Z_AXIS)
		trans=Geom::Transformation.new(z_axis.reverse,z_axis.cross(x_axis),Z_AXIS,post_location)
	else
		trans=Geom::Transformation.new(Z_AXIS.cross(x_axis),x_axis.reverse,Z_AXIS,post_location)
	end
else
	trans=Geom::Transformation.new(z_axis.reverse,x_axis.reverse,y_axis,post_location)
end
case post.rotation
	when "0","90","180","270"
		angle=post.rotation.to_f.degrees
		rot_trans=Geom::Transformation.rotation(Geom::Point3d.new(0,0,0),trans.zaxis,angle)	
	when "Average"
		angle=get_average_post_angle(trans,curve,distance_from_curve_start)
		rot_trans=Geom::Transformation.rotation(Geom::Point3d.new(0,0,0),trans.zaxis,angle)
	when "Random"
		angle=rand*Math::PI*2.0
		rot_trans=Geom::Transformation.rotation(Geom::Point3d.new(0,0,0),trans.zaxis,angle)	
	when "Smooth"
		rot_trans=Geom::Transformation.new
end
if post.mirror?
	scale_trans=Geom::Transformation.scaling(1.0,-1.0,1.0)
else
	scale_trans=Geom::Transformation.new
end
trans=trans*rot_trans*scale_trans
post.add_instance(trans,edge)
return
end
###
def get_post_location_on_curve(post,curve,distance_from_curve_start)
curve_pts=curve.points
x=0.0
pt_index=0
edge_start_point=curve_pts[0]
edge_end_point=curve_pts[1]
xy_plane=[Geom::Point3d.new(0,0,0), Geom::Vector3d.new(0,0,1)]
is_horizontal_layout=post.horizontal_layout?
is_horizontal_layout=false unless post.at_infill?
if is_horizontal_layout
	current_edge_length=edge_start_point.project_to_plane(xy_plane).distance(edge_end_point.project_to_plane(xy_plane))
else	
	current_edge_length=edge_start_point.distance(edge_end_point)
end
if distance_from_curve_start<=0.0
	distance_along_this_edge=distance_from_curve_start
	edge_line_containing_post=[edge_start_point,edge_end_point]
elsif distance_from_curve_start>curve.length
	edge_start_point=curve_pts[-2]
	edge_end_point=curve_pts[-1]
	distance_along_this_edge=edge_start_point.distance(edge_end_point)+(distance_from_curve_start-curve.length.to_f)
	edge_line_containing_post=[edge_start_point,edge_end_point]
else
	while (x<distance_from_curve_start)
		
		edge_start_point=curve_pts[pt_index]
		edge_end_point=curve_pts[pt_index+1]
		
		if is_horizontal_layout and post.at_infill?
			edge_start_point=edge_start_point.project_to_plane(xy_plane)
			edge_end_point=edge_end_point.project_to_plane(xy_plane)
		end
		
		current_edge_length=edge_start_point.distance(edge_end_point)  
		x=x+current_edge_length
		pt_index+=1
	end
	distance_along_this_edge=distance_from_curve_start-(x-current_edge_length)
	edge_line_containing_post=[curve_pts[pt_index-1],curve_pts[pt_index]]
end
overall_path_pt_index=@chain.path.index(edge_line_containing_post[0])
curve_axis_transform=@chain.transformation_at(overall_path_pt_index)
x_axis=curve_axis_transform.xaxis
y_axis=curve_axis_transform.yaxis
z_axis=curve_axis_transform.zaxis
offset_along_edge=z_axis.reverse
if is_horizontal_layout and !(z_axis.parallel?(Z_AXIS))
	offset_along_edge.z=0.0
end
offset_along_edge.length=distance_along_this_edge
if is_horizontal_layout
	flattened_edge_line_containing_post=[edge_start_point,edge_end_point]
	flattened_post_location=edge_start_point.offset(offset_along_edge)
	vertical_line=[flattened_post_location,Geom::Vector3d.new(0,0,1)]
	post_location=Geom.intersect_line_line(vertical_line, edge_line_containing_post)
	if post_location==nil
		post_location=edge_start_point.offset(offset_along_edge)
	end
else
	post_location=edge_start_point.offset(offset_along_edge)
end
if post.rotation=="Smooth"
	num_points=@chain.num_points
	edges=@chain.edges()
	num_edges=edges.length
	
	if (overall_path_pt_index!=(num_points-1)) and (num_points>2)
		
		prev_trans=@chain.transformation_at(overall_path_pt_index-1)
		prev_edge=edges[overall_path_pt_index-1]
		prev_edge_length=prev_edge[0].vector_to(prev_edge[1]).length
		
		if @chain.closed_path? and overall_path_pt_index==(num_points-2)
			next_trans=@chain.transformation_at(0)
			next_edge=edges[0]
			next_edge_length=next_edge[0].vector_to(next_edge[1]).length
		else
			if overall_path_pt_index==(num_points-2)
				next_trans=@chain.transformation_at(overall_path_pt_index)
				next_edge=edges[overall_path_pt_index]
				next_edge_length=next_edge[0].vector_to(next_edge[1]).length
			else
				next_trans=@chain.transformation_at(overall_path_pt_index+1)
				next_edge=edges[overall_path_pt_index+1]
				next_edge_length=next_edge[0].vector_to(next_edge[1]).length
			end
		end
		
		half_prev_edge_length=prev_edge_length/2.0
		half_next_edge_length=next_edge_length/2.0
		half_current_edge_length=current_edge_length/2.0
		
		dist_midprev_midthis=half_prev_edge_length+half_current_edge_length
		dist_midthis_midnext=half_current_edge_length+half_next_edge_length
		
		ratio_along_this_edge=distance_along_this_edge/current_edge_length
		if (ratio_along_this_edge)<=0.5
			factor=(half_prev_edge_length+distance_along_this_edge)/dist_midprev_midthis
			curve_axis_transform=Geom::Transformation.interpolate(prev_trans,curve_axis_transform,factor)
		else
			dist_from_this_edge_end=(1.0-ratio_along_this_edge)*current_edge_length
			factor=(half_current_edge_length-dist_from_this_edge_end)/dist_midthis_midnext
			curve_axis_transform=Geom::Transformation.interpolate(curve_axis_transform,next_trans,factor)
		end
		x_axis=curve_axis_transform.xaxis
		y_axis=curve_axis_transform.yaxis
		z_axis=curve_axis_transform.zaxis
		
	end
end
trans=Geom::Transformation.new(x_axis,y_axis,z_axis,post_location)
return trans,edge_line_containing_post
end
#
def get_average_post_angle(post_trans,curve,distance_from_curve_start)
all_points=@chain.path
all_edges=[]
up_axis=post_trans.zaxis
temp_chain=Chain.new(all_points)
all_edges=temp_chain.edges()
if distance_from_curve_start==0.0
	next_edge=curve.first_edge
	next_edge_index=all_edges.index(next_edge)
	if next_edge_index==0
		angle=0.0
	else
		previous_edge=all_edges[next_edge_index-1]
		v1=previous_edge[0].vector_to(previous_edge[1])
		v2=next_edge[0].vector_to(next_edge[1])
		v3=v1.cross(v2)
		angle=((v1.angle_between(v2))/2.0)
		if v3.angle_between(up_axis)<(Math::PI/2.0)
			angle=-angle
		end
	end
elsif distance_from_curve_start==curve.length.to_f
	previous_edge=curve.last_edge
	previous_edge_index=all_edges.index(previous_edge)
	if previous_edge_index==(all_edges.length-1)
		angle=0.0
	else
		next_edge=all_edges[previous_edge_index+1]
		v1=previous_edge[0].vector_to(previous_edge[1])
		v2=next_edge[0].vector_to(next_edge[1])
		v3=v1.cross(v2)
		angle=(v1.angle_between(v2))/2.0
		if v3.angle_between(up_axis)<(Math::PI/2.0)
			angle=-angle
		end
	end
else
	angle=0.0
end
return angle
end
##
def load_from_defn(su_defn)
new_posts=[]
new_rails=[]
dicts=su_defn.attribute_dictionaries
if dicts and dicts[@dict]
	
	fence_dict=dicts[@dict]
	self.description=su_defn.description
	self.name=su_defn.get_attribute(@dict,"name",su_defn.name)
	fence_dict.each_pair {|key,value|
	
	if key.split("Post").length>1 #we have a post
		post_index=key.split("Post")[1].to_i
		new_post=Post.new(value)
		new_posts[post_index]=new_post
	elsif key.split("Rail").length>1 #we have a rail
		rail_index=key.split("Rail")[1].to_i
		new_rail=Rail.new(value)
		new_rails[rail_index]=new_rail
	end
	}
		
	new_posts.each {|post| self.add_post(post)}
	new_rails.each {|rail| self.add_rail(rail)}
end
end
end #class fence
#
class Assembly
private_class_method :new
@@dict="PBFence"
@@path=[]
def Assembly.add(ents)
group=ents.add_group()
assembly=new(group)
return assembly
end
##
def Assembly.create_in(defn)
assembly=new(defn)
return assembly
end
##
def Assembly.get(ent)
if Classify.assembly?(ent)
	a=new(ent)
else
	a=nil
end
return a
end
##
def initialize(object)
if object.class==Sketchup::ComponentInstance
	@su_defn=object.definition
elsif object.class==Sketchup::Group
	@su_defn=object.entities.parent
elsif object.class==Sketchup::ComponentDefinition
	@su_defn=object
end
@instance=object
@fence=Fence.new
load_fence()
end
##
def transformation
return @instance.transformation
end
##
def fence=(f)
@fence=f
end
def fence
@fence
end
##
def draw()
@ents=@su_defn.entities
@ents.clear!
pts=self.chain
@fence.calc_posts_layout(pts)
build_posts()
build_rails()
save_fence_properties_to_defn()
end
##
def build_posts()
posts=@fence.posts
posts.each {|post|
	next unless post.valid?
	post.instances.each {|edge,tranformations|
		tranformations.each {|trans|
			inst=@ents.add_instance(post.component_definition,trans)
			inst.layer=Sketchup.active_model.layers[post.layer_name]
			post_index=posts.index(post)
			inst.definition.set_attribute(@dict,"Post#{post_index}",post.to_s)
		}
	}
}
end
#
def build_rails()
path_pts=self.chain
rails=@fence.rails
rails.each {|rail|
	next if !rail.valid?
	rail_chain=Chain.new(path_pts)
	profile=rail.profile
	rail_chain=rail.offset_chain(rail_chain)
	rail_pts=rail_chain.path
	pm=ProfileMember.add(@ents,rail_pts)
	pm.set_from_profile!(profile) 
	pm.draw()
	unless rail_chain.closed_path?
		pm.extend_start(-(rail.start_setback)) if rail.start_setback!=0.0 
		pm.extend_end(-(rail.end_setback)) if rail.end_setback!=0.0 
	end
	rail_index=rails.index(rail)
	pm.definition.set_attribute(@dict,"Rail#{rail_index}",rail.to_s)
}
end
##
def set_chain(pts,trans=nil)
trans=Geom::Transformation.new unless trans
pts=pts.collect {|p| p.transform(trans.inverse).to_a}
@su_defn.set_attribute(@@dict,'path',pts)
end
##
def chain
pts=@su_defn.get_attribute(@@dict,'path',@@path)
pts=pts.collect {|p| Geom::Point3d.new(p)}
return pts
end
#
def save_fence_properties_to_defn()
posts=@fence.posts 
rails=@fence.rails
dicts=@su_defn.attribute_dictionaries
#dicts.delete(@@dict) if dicts
@su_defn.description=@fence.description
@su_defn.name=@fence.name
@su_defn.set_attribute(@@dict,"is_fence",true)
@su_defn.set_attribute(@@dict,"name",@fence.name)
posts.each_index {|i|
	@su_defn.set_attribute(@@dict,"Post#{i}",posts[i].to_s)
}
rails.each_index {|i|
	@su_defn.set_attribute(@@dict,"Rail#{i}",rails[i].to_s)
}
end #save fence properties
##
def clear_existing_entities()
ents=@su_defn.entities
ents.clear!
end
##
def draw_path()
clear_existing_entities()
ents=Sketchup.active_model.active_entities
trans=Sketchup.active_model.edit_transform
chain=self.chain
edges=[]
(chain.length-1).times {|i|
	p0=chain[i].transform(trans)
	p1=chain[i+1].transform(trans)
	edges.push(ents.add_line([p0,p1]))
}
return edges
end
##
def draw_path_group()
trans=@instance.transformation
pts=self.chain
group=Sketchup.active_model.active_entities.add_group
group_ents=group.entities
group.transform! trans
group_ents.add_edges(pts)
return group
end
##
def load_fence()
@fence.load_from_defn(@su_defn)
end
##
def valid?
if @su_defn.class==Sketchup::ComponentDefinition and @su_defn.valid?
	return true
else
	return false
end
end
##
def pmpi()
@instance.hidden=true
@instance.set_attribute('PMPI','pmpi_hidden',true)
path=self.draw_path_group
path.set_attribute('PMPI','pmpi_path',true)
end
end #class fencedefinition
end #module ProfileBuilder2

end #module DM
