require 'sketchup.rb'
module DM
module ProfileBuilder2
class TrimTool
GETFIRSTMEMBER=0
GETSECONDMEMBER=1
ERROR_MESSAGE="想要修剪, 轮廓放样的端头必须是没有修改的.是否重建轮廓放样?"
include Geometry

def initialize
@sel=Sketchup.active_model.selection	
@dict="ProfileBuilder"
@ip = Sketchup::InputPoint.new
@cap_index=nil
@picked_face_trans=nil
ro=Sketchup.active_model.rendering_options
@highlight_color=ro["HighlightColor"]
@previewer=ComponentPreviewer.new
set_cursors()
end
def set_cursors()
plugins = PATH
icon = File.join(plugins, "cursors","trim_solid_1.png")
@cursor1=UI.create_cursor(icon,1,1)
icon = File.join(plugins, "cursors","trim_solid_2.png")
@cursor2=UI.create_cursor(icon,1,1)
end
##############
def activate
if !Sketchup.is_pro?
	UI.messagebox("此功能需要SketchUp Pro才能使用。")
	Sketchup.active_model.select_tool(nil)
end
self.reset()
end
def reset()
@trimmer_instance=nil  
@picked_inst=nil 
@state=0
@cap_index=nil
@sel.clear
@ip.clear
set_status_text()
end
#
def onCancel(flag, view)
    self.reset()
end
def set_status_text()
case @state
	when GETFIRSTMEMBER
		Sketchup::set_status_text("选择实体用于修剪.")
	when GETSECONDMEMBER
		Sketchup::set_status_text("选择一个轮廓放样模型用于修剪.点击ESC重新选择.")
end
end
################
def onSetCursor
case @state
	when GETFIRSTMEMBER
		UI.set_cursor(@cursor1) if @cursor1
	when GETSECONDMEMBER
		UI.set_cursor(@cursor2) if @cursor2
end

end
##############
def deactivate(view)
end
############
def onLButtonDown(flags,x,y,view)
if @state==GETFIRSTMEMBER
	if @trimmer_instance!=nil
		@state=GETSECONDMEMBER
		set_status_text()
	end
elsif @state==GETSECONDMEMBER	
	if @picked_inst!=nil
		pickray=view.pickray(x,y)
		pm_first=ProfileMember.new(@picked_inst)
		@cap_index=pm_first.get_picked_cap_face_index(pickray)
		cap_faces=pm_first.get_perpendicular_cap_faces()
		@picked_cap_face=cap_faces[@cap_index]
		if @picked_cap_face==nil
			result=UI.messagebox(ERROR_MESSAGE,MB_YESNO)
			if result==6
				Sketchup.active_model.start_operation("Untrim",true)
				pm_first.draw()
				Sketchup.active_model.commit_operation
			end
		else
			perform_trim()
		end
	end
end
view.invalidate
end  #end onLbuttondown
def onMouseMove(flags,x,y,view)
ph=view.pick_helper
pickray=view.pickray(x,y)
ph.do_pick(x,y)
best=get_inst_below_cursor(view,x,y)
@sel.clear
case @state
when GETFIRSTMEMBER
	if best and best.respond_to?(:manifold?) and best.manifold?
		@trimmer_instance=best
		@sel.add(best)
	else
		@trimmer_instance=nil
	end
when GETSECONDMEMBER
	if Classify.profile_member?(best) and best.manifold? and best!=@trimmer_instance
		@picked_inst=best 
		get_cap_face_below_cursor(view,x,y)
		@sel.add(best)
		#pm=ProfileMember.new(best)
		#trans=pm.transformation
		#chain=pm.chain
		#pm.get_closest_path_point(pickray)
		#@closest_point=chain.closest_point_on_path(pickray,trans)
	else
		@picked_inst=nil
	end
	@sel.add(@trimmer_instance) if @trimmer_instance
end
end
##
def get_cap_face_below_cursor(view,x,y)
@cap_index=nil
@picked_cap_face=nil
pickray=view.pickray(x,y)
pm_first=ProfileMember.new(@picked_inst)
@cap_index=pm_first.get_picked_cap_face_index(pickray)
cap_faces=pm_first.get_cap_vertices()
@picked_cap_face=cap_faces[@cap_index]
if pm_first.profile.is_1d?
	@is_polyline=true
else
	@is_polyline=false
end
unless @picked_cap_face
	@cap_index=nil
	@is_polyline=false
end
end
##
def get_closest_face_verts_to_input_point(face_verts,trans)
cursor_point=@ip.position
distance_to_ip=[]
face_verts.each_index {|index|
	verts=face_verts[index]
	box=Geom::BoundingBox.new
	face_pts=verts.collect {|v| v.position.transform(trans)}
	box.add(face_pts)
	face_center=box.center
	distance_to_ip.push(face_center.vector_to(cursor_point).length)
}
min_distance=distance_to_ip.min
min_index=distance_to_ip.index(min_distance)
return face_verts[min_index]
end
##############
def perform_trim()
begin
	Sketchup.active_model.start_operation("Trim", true)
	trim()
	Sketchup.active_model.commit_operation
rescue ProfileMember::TrimException => err
	Sketchup.active_model.abort_operation
	#p "Trim Exception!!"
	UI.messagebox(err.message)
rescue
	Sketchup.active_model.abort_operation
	raise
end
 
end #perform trim
###
def trim()
pm=ProfileMember.new(@picked_inst)
if @index==0
	pm.trim_to(@trimmer_instance,@cap_index)
else
	pm.trim_to(@trimmer_instance,@cap_index)
end
end
def draw(view)
view.drawing_color="blue"
view.line_width=3
case @state
	when GETFIRSTMEMBER
		#view.draw_points(@closest_point[0], 10, 1, "red") if @closest_point
		
	when GETSECONDMEMBER
		if @picked_inst and @picked_cap_face and @picked_inst.valid?
			draw_picked_face(view,@picked_cap_face,@picked_inst.transformation)
		end
end
end
##
def draw_bounds(inst)
defn=@trimmer_instance.definition
@previewer.definition=defn
@previewer.transformation=@trimmer_instance.transformation
@previewer.draw_bounds()
end

end  #end class

##
class TrimtoFaceTool < TrimTool
GETFACE=0
GETMEMBER=1
def reset()
super
@trim_plane=nil
@picked_face_trans=nil
@trim_plane=nil
end
##
def set_cursors()
plugins = PATH
icon = File.join(plugins, "cursors","trim_face_1.png")
@cursor1=UI.create_cursor(icon,1,1)
icon = File.join(plugins, "cursors","trim_face_2.png")
@cursor2=UI.create_cursor(icon,1,1)
end
##
def activate
self.reset()
end
##
def set_status_text()
case @state
	when GETFACE
		Sketchup::set_status_text("选择一个要修剪到的面.")
	when GETSECONDMEMBER
		Sketchup::set_status_text("选择一个轮廓放样模型用于修剪.点击ESC重新选择.")
end
end
##
def get_face_below_cursor(x,y,view)
@picked_face_trans=nil
pickray=view.pickray(x,y)
model=Sketchup.active_model
rt=model.raytest(pickray)
if rt
	path=rt[1]
	ent=path.last
	if ent.class==Sketchup::Face
		@picked_face_trans=[]
		@picked_face_trans[0]=path.pop()
		trans=Geom::Transformation.new
		path.each {|inst| trans=trans*inst.transformation}
		@picked_face_trans[1]=trans
	end
end
end
##
def get_face_plane_below_cursor(x,y,view)
get_face_below_cursor(x,y,view)
if @picked_face_trans
	trans=@picked_face_trans[1]
	face=@picked_face_trans[0]
	p0=face.vertices[0].position.transform(trans)
	plane=[p0,face.normal.transform(trans)]
else
	plane=nil
end
return plane
end
##
def onLButtonDown(flags,x,y,view)
if @state==GETFACE
	@trim_plane=get_face_plane_below_cursor(x,y,view)
	if @trim_plane
		@state=GETMEMBER
		set_status_text()
	end
elsif @state==GETMEMBER	
	if @picked_inst!=nil
		get_cap_face_below_cursor(view,x,y)
		pm_first=ProfileMember.new(@picked_inst)
		if @picked_cap_face==nil
			result=UI.messagebox(ERROR_MESSAGE,MB_YESNO)
			if result==6
				Sketchup.active_model.start_operation("Untrim",true)
				pm_first.draw()
				Sketchup.active_model.commit_operation
			end
		else
			perform_trim()
			@cap_index=nil
			@picked_cap_face=nil
		end
	end
end
view.invalidate
end
##
def onMouseMove(flags,x,y,view)
@sel.clear
case @state
when GETFACE
	get_face_below_cursor(x,y,view)
when GETMEMBER
	best=get_inst_below_cursor(view,x,y)
	if (Classify.profile_member?(best)) #and (!@picked_face_trans[0].parent==best.definition)
		@picked_inst=best
		get_cap_face_below_cursor(view,x,y)
		@sel.add(best)
	else
		@picked_inst=nil
	end
end
view.invalidate
end
##
def draw(view)
case @state
	when GETFACE
		if @picked_face_trans
			draw_picked_face(view,@picked_face_trans[0],@picked_face_trans[1])
		end
	when GETMEMBER
		if @picked_inst and @picked_cap_face and @picked_inst.valid?
			draw_picked_face(view,@picked_cap_face,@picked_inst.transformation,@is_polyline)
		end
		draw_picked_face(view,@picked_face_trans[0],@picked_face_trans[1])
end
end
##
##############
def perform_trim()
begin
	if @trim_plane
		Sketchup.active_model.start_operation("Trim", true)
		trim_to_plane()
		Sketchup.active_model.commit_operation
	end
rescue ProfileMember::TrimException => err
	UI.messagebox(err.message)
	Sketchup.active_model.abort_operation
rescue
	raise
end
end #perform trim
##
def trim_to_plane()
pm_first=ProfileMember.new(@picked_inst)
if @cap_index
	pm_first.trim_to_plane(@trim_plane,@cap_index)
end
return
end
end #class
end #module ProfileBuilder2

end #module DM
