require "sketchup.rb"
# Main code (start module name with capital letter)


module Adc_sketchup





 def self.insert_adc
	model = Sketchup.active_model
	
	adc_path = Sketchup.find_support_file "ADC-Theatre.skp", "Plugins/af_Custom/components"
	adc_def = model.definitions.load adc_path
	adc_location = Geom::Point3d.new 0,0,0
	transform = Geom::Transformation.new adc_location
	entities = model.active_entities
	instance = entities.add_instance adc_def, transform
	instance.locked = true
	if(model.pages.length==0)
		target = [246,-300,70]
		up = [0,0,1]
		eye_a1 = [105.95, -485.8, 15.75]
		eye_a14 = [381.5, -485.8, 15.75]
		eye_j7 = [243.7, -722.6, 59.25]
		eye_p1 = [72.5, -960.2,114.2]
		eye_p18 = [417.9,-960.2,114.2]
		eye_start = [708.7, -551.2, 320.75]
		
		camera_a1 = Sketchup::Camera.new eye_a1, target, up, true, 50.0
		camera_a14 = Sketchup::Camera.new eye_a14, target, up, true, 50.0
		camera_j7 = Sketchup::Camera.new eye_j7, target, up, true, 50.0
		camera_p1 = Sketchup::Camera.new eye_p1, target, up, true, 50.0
		camera_p18 = Sketchup::Camera.new eye_p18, target, up, true, 50.0
		camera_start = Sketchup::Camera.new eye_start, [0,0,-200], up, true, 50.0
		
		model.active_view.camera = camera_a1
		a1 = model.pages.add("A1",1)
		a1.transition_time = 0.5
		
		model.active_view.camera = camera_a14
		a14 = model.pages.add("A14",1)
		a14.transition_time = 0.5
		
		model.active_view.camera = camera_j7
		j7 = model.pages.add("J7",1)
		j7.transition_time = 0.5
		
		model.active_view.camera = camera_p1
		p1 = model.pages.add("P1",1)
		p1.transition_time = 0.5
		
		model.active_view.camera = camera_p18
		p18 = model.pages.add("P18",1)
		p18.transition_time = 0.5
		
		model.active_view.camera = camera_start
	end

end
 
 #################################################
	
	
	#{Adc_sketchup::insert_TCTY}
	def self.insert_TCTY
	model = Sketchup.active_model
	stripwood_path = Sketchup.find_support_file "TCTY.skp" ,"Plugins/af_Custom/components"
	stripwood_def = model.definitions.load stripwood_path
	model.place_component(stripwood_def)
	end
	
	
	#{Adc_sketchup::insert_TCGZ}
	def self.insert_TCGZ
	model = Sketchup.active_model
	stripwood_path = Sketchup.find_support_file "TCGZ.skp" ,"Plugins/af_Custom/components"
	stripwood_def = model.definitions.load stripwood_path
	model.place_component(stripwood_def)
	end

	#{Adc_sketchup::insert_TCLB}
	def self.insert_TCLB
	model = Sketchup.active_model
	stripwood_path = Sketchup.find_support_file "TCLB.skp" ,"Plugins/af_Custom/components"
	stripwood_def = model.definitions.load stripwood_path
	model.place_component(stripwood_def)
	end
	
	#{Adc_sketchup::insert_TCCB}
	def self.insert_TCCB
	model = Sketchup.active_model
	stripwood_path = Sketchup.find_support_file "TCCB.skp" ,"Plugins/af_Custom/components"
	stripwood_def = model.definitions.load stripwood_path
	model.place_component(stripwood_def)
	end
	
	#{Adc_sketchup::insert_TCHB}
	def self.insert_TCHB
	model = Sketchup.active_model
	stripwood_path = Sketchup.find_support_file "TCHB.skp" ,"Plugins/af_Custom/components"
	stripwood_def = model.definitions.load stripwood_path
	model.place_component(stripwood_def)
	end
	
	#{Adc_sketchup::insert_TCBJ}
	def self.insert_TCBJ
	model = Sketchup.active_model
	stripwood_path = Sketchup.find_support_file "TCBJ.skp" ,"Plugins/af_Custom/components"
	stripwood_def = model.definitions.load stripwood_path
	model.place_component(stripwood_def)
	end
	
	
	
	def self.insert_TCZJGZ
	model = Sketchup.active_model
	stripwood_path = Sketchup.find_support_file "TCZJGZ.skp" ,"Plugins/af_Custom/components"
	stripwood_def = model.definitions.load stripwood_path
	model.place_component(stripwood_def)
	end
	
	
	def self.insert_TCZJ
	model = Sketchup.active_model
	stripwood_path = Sketchup.find_support_file "TCZJ.skp" ,"Plugins/af_Custom/components"
	stripwood_def = model.definitions.load stripwood_path
	model.place_component(stripwood_def)
	end
	
	
	def self.insert_TCZJZK
	model = Sketchup.active_model
	stripwood_path = Sketchup.find_support_file "TCZJZK.skp" ,"Plugins/af_Custom/components"
	stripwood_def = model.definitions.load stripwood_path
	model.place_component(stripwood_def)
	end
	
	
	
	
	
	
	##################################################
 
 def self.insert_frame
	model = Sketchup.active_model
	frame_path = Sketchup.find_support_file "Assembly-frame.skp" ,"Plugins/af_Custom/components"
	frame_def = model.definitions.load frame_path
	frame = model.place_component(frame_def)
 end
  def self.insert_deck
	model = Sketchup.active_model
	deck_path = Sketchup.find_support_file "Assembly-deck.skp" ,"Plugins/af_Custom/components"
	deck_def = model.definitions.load deck_path
	model.place_component(deck_def)
 end
	def self.insert_treads
	model = Sketchup.active_model
	prompt = ["Tread height? (feet)"]
	default = ["2"]
	list = ["2|3|4|5|6|7"]
	handrail_prompt = ["Handrail?"]
	handrail_default = ["Yes"]
	handrail_list = ["Yes|No"]
	input = UI.inputbox(prompt, default, list, "Tread Height")
	handrail_input = UI.inputbox(handrail_prompt, handrail_default, handrail_list, "Handrail")
	number = input[0].to_i
	string = number.to_s
	if handrail_input[0].to_s == "Yes"
		filename = "treads-#{string}.skp"
	else
		filename = "treads-#{string}-nh.skp"
	end
 	tread_path = Sketchup.find_support_file filename ,"Plugins/af_Custom/components"
	tread_def = model.definitions.load tread_path
	model.place_component(tread_def)
	end

	def self.insert_handrail
	model = Sketchup.active_model
	prompt = ["Handrail length? (m)"]
	default = ["1"]
	list = ["1|2"]
	handrail_prompt = ["Angled (45 degrees)?"]
	handrail_default = ["No"]
	handrail_list = ["No|Yes"]
	input = UI.inputbox(prompt, default, list, "Handrail Length")
	angle_input = UI.inputbox(handrail_prompt, handrail_default, handrail_list, "Angled")
	length = input[0].to_i
	string = length.to_s
	if angle_input[0].to_s == "No"
		filename = "handrail-#{string}m.skp"
	else
		filename = "handrail-#{string}m-45.skp"
	end
 	handrail_path = Sketchup.find_support_file filename ,"Plugins/af_Custom/components"
	handrail_def = model.definitions.load handrail_path
	model.place_component(handrail_def)
	end
	
	
	 def self.insert_stripwood
	model = Sketchup.active_model
	stripwood_path = Sketchup.find_support_file "stripwood.skp" ,"Plugins/af_Custom/components"
	stripwood_def = model.definitions.load stripwood_path
	model.place_component(stripwood_def)
	end
	
	def self.insert_sheetwood
	model = Sketchup.active_model
	sheetwood_path = Sketchup.find_support_file "sheetwood.skp" ,"Plugins/af_Custom/components"
	sheetwood_def = model.definitions.load sheetwood_path
	model.place_component(sheetwood_def)
	end
	
	def self.rotate_90_r
	model = Sketchup.active_model
	xt = 0
	yt = 0
	zt = 0
	model.selection.each{	|entity| 
							xt = xt + entity.bounds.center.x
							yt = yt + entity.bounds.center.y
							zt = zt + entity.bounds.center.z
						}
	number = model.selection.count
	xt = xt/number
	yt = yt/number
	zt = zt/number
	transformation = Geom::Transformation.rotation [xt,yt,zt], [1,0,0], 90.degrees
	Sketchup.active_model.active_entities.transform_entities(transformation,Sketchup.active_model.selection)
	end
	
	def self.rotate_90_g
	model = Sketchup.active_model
	xt = 0
	yt = 0
	zt = 0
	model.selection.each{	|entity| 
							xt = xt + entity.bounds.center.x
							yt = yt + entity.bounds.center.y
							zt = zt + entity.bounds.center.z
						}
	number = model.selection.count
	xt = xt/number
	yt = yt/number
	zt = zt/number
	transformation = Geom::Transformation.rotation [xt,yt,zt], [0,1,0], 90.degrees
	Sketchup.active_model.active_entities.transform_entities(transformation,Sketchup.active_model.selection)
	end
	
	def self.rotate_90_b
	model = Sketchup.active_model
	xt = 0
	yt = 0
	zt = 0
	model.selection.each{	|entity| 
							xt = xt + entity.bounds.center.x
							yt = yt + entity.bounds.center.y
							zt = zt + entity.bounds.center.z
						}
	number = model.selection.count
	xt = xt/number
	yt = yt/number
	zt = zt/number
	transformation = Geom::Transformation.rotation [xt,yt,zt], [0,0,1], 90.degrees
	Sketchup.active_model.active_entities.transform_entities(transformation,Sketchup.active_model.selection)
	end
	
end

#unless file_loaded?(__FILE__)
 #mymenu = UI.menu("Plugins").add_submenu("ADC Sketchup")
 #mymenu.add_item("ADC") {Adc_sketchup::insert_adc}
 #mymenu.add_item("Frame") {Adc_sketchup::insert_frame}
 #mymenu.add_item("Deck") {Adc_sketchup::insert_deck}
 #mymenu.add_item("Treads") {Adc_sketchup::insert_treads}
 #mymenu.add_item("Handrail") {Adc_sketchup::insert_handrail}
 #mymenu.add_item("Stripwood") {Adc_sketchup::insert_stripwood}
 #mymenu.add_item("Sheetwood") {Adc_sketchup::insert_sheetwood}
 #mymenu.add_item("Rotate 90 Red") {Adc_sketchup::rotate_90_r}
 #mymenu.add_item("Rotate 90 Green") {Adc_sketchup::rotate_90_g}
 #mymenu.add_item("Rotate 90 Blue") {Adc_sketchup::rotate_90_b}
 
 #file_loaded(__FILE__)
#end