#Throw_afu.rb
#Auther :TAK2HATA
#version0
#Update Mar 30,2013.
#site: http://sketchup-onigiri.jimdo.com/
###日本語
#General disclaimer
#I MAKES NO GUARANTEE OF VALIDITY about this script.
#Please use this script at your own risk.
##免責事項
##このスクリプトによって如何なる損害が発生しても製作者は責任を負いません。各人の責任においてご使用ください。
#
require 'sketchup.rb'

class Throw_afu
	def initialize
		if Sketchup.active_model.selection.count == 0
			UI.messagebox "“请在启动此工具之前至少选择一个实体。."
			deactivate
		end
	end

	def activate
		@ip         = Sketchup::InputPoint.new
		@ip1        = Sketchup::InputPoint.new
		@ip2        = Sketchup::InputPoint.new
		view.invalidate if @drawn
		@drawn      = true
		self.reset(nil)
	end

	def resume(view)
	end

	def deactivate(view)
		view.invalidate if @drawn
	end

	def onCancel(flag, view)
		self.reset(view)
	end

	def reset(view)
		@state = 0
		@message = "第一次点击"
		Sketchup.set_status_text( @message )
		@ip1.clear
		@ip2.clear
		@ip.clear
		if( view )
			view.tooltip = nil
			view.invalidate if @drawn
		end
		@drawn = false
	end
	def draw(view)
		if( @ip1.valid? )
			if( @ip1.display? )
				@ip1.draw(view)
				@drawn = true
			end
			if( @ip2.valid? )
				@ip2.draw(view) if( @ip2.display? )
				if view.inference_locked?
					line_width = 2
				else
					line_width = 1
				end
				view.line_width = line_width
				view.set_color_from_line(@ip1, @ip2)
				view.draw_line(@ip1.position, @ip2.position)
				@drawn = true
			end
		end
		Sketchup.set_status_text( @message )
	end
	def onMouseMove(flags, x, y, view)
		if( @state == 0 )
			@ip.pick view, x, y
			if( @ip != @ip1 )
				view.invalidate if( @ip.display? or @ip1.display? )
				@ip1.copy! @ip
				view.tooltip = @ip1.tooltip
			end
		else
			@ip2.pick view, x, y, @ip1
			view.tooltip = @ip2.tooltip if( @ip2.valid? )
			view.invalidate
		end
	end
	def onLButtonDown(flags, x, y, view)
		if( @state == 0 )
			@ip1.pick view, x, y
			if( @ip1.valid? )
				@state = 1
				@message = "Click Second Point"
			end
		else
			# create the line on the second click
			if( @ip2.valid? )
				start_throwing(@ip1.position, @ip2.position)
				self.reset(view)
			end
		end
		# Clear any inference lock
		view.lock_inference
	end
	def start_throwing( pt1 , pt2 )
		return if not pt1.vector_to( pt2 ).valid?
		model = Sketchup.active_model
		ents = model.active_entities
		vec = pt1.vector_to( pt2 )
		tvecs = []
		tents = []
		sels = model.selection
		Sketchup.active_model.start_operation "Throw to Infinity"#
		sels.each{|sel2| sel2.hidden = true }
		sels.each{|sel|
			pts = []
			sel.hidden = false
			pts = get_all_vt_pts( sel )
			pts2 = pts.uniq.compact
			dist = model.bounds.diagonal
			tvec = Geom::Vector3d.new(0,0,0)
			#pt3,vec,sel
			sel.hidden = true
			pts2.each{|pt3|
				ray = [ pt3 , vec ]
				items = model.raytest( ray )
				if items and items != []
					pt4 = items[0]
					tdist = pt4.distance( pt3 )
					if  tdist != 0.0 and tdist < dist
						dist = pt4.distance( pt3 )
						tvec = pt3.vector_to( pt4 )
					end
				end
			}
			
			if tvec.valid?
				tents.push sel
				tvecs.push tvec
			end
		}
		sels.each{|sel2| sel2.hidden = false }
		if tents != []
			ents.transform_by_vectors tents, tvecs
		end
		Sketchup.active_model.commit_operation
	end
	def get_all_vt_pts( e , gtr = Geom::Transformation.new )
		if e.kind_of? Sketchup::Group
			tr = e.transformation
			pts = []
			e.entities.each{|e2|
				pts.push get_all_vt_pts( e2 , gtr * tr )
			}
			return pts.flatten
		elsif e.kind_of? Sketchup::ComponentInstance 
			tr = e.transformation
			pts = []
			e.definition.entities.each{|e2|
				pts.push get_all_vt_pts( e2 , gtr * tr )
			}
			return pts.flatten
		elsif ( e.kind_of? Sketchup::Face or e.kind_of? Sketchup::Edge ) and e.visible?
			return e.vertices.map{|vt| vt.position.transform( gtr ) }
		end
	end

end # Class Throw_afu



class Throw_afu_face
	def initialize
		if Sketchup.active_model.selection.count == 0
			UI.messagebox "请选择实体"
			deactivate
		end
	end

	def activate
		@drawn = false
		@ip = Sketchup::InputPoint.new
		self.reset(nil)
	end

	def resume(view)
	end

	def deactivate(view)
		view.invalidate if @drawn
	end

	def onCancel(flag, view)
		self.reset(view)
	end

	def reset(view)
		@ip.clear
		@message = "选择要靠齐的面"
		@pts = []
		Sketchup.set_status_text( @message )
		if( view )
			view.tooltip = nil
			view.invalidate if @drawn
		end
		@drawn = false
	end
	def draw(view)
		Sketchup.set_status_text( @message )
		if @pts != []
			view.line_width = 4
			view.drawing_color="red"
			@pts.push @pts[0] if @pts[0] != @pts[-1]
			view.draw_polyline(@pts)
		end
		@drawn = true
	end
	def onMouseMove(flags, x, y, view)
		@ip.pick( view, x, y )
		if @ip.face and @ip.face.visible?
			tr = @ip.transformation
			@pts = @ip.face.vertices.map{|vt| vt.position.transform( tr ) }
			view.invalidate# if @drawn
		else
			@pts = []
		end
	end
	def onLButtonDown(flags, x, y, view)
		@ip.pick( view, x, y )
		if @ip.face
			tr = @ip.transformation
			plane = [ @ip.face.vertices[0].position.transform( tr ) , @ip.face.normal.transform( tr ) ]
			start_throwing_plane( plane , tr )
			self.reset(view)
		end
	end
	def start_throwing_plane( plane , tr )
		vec = plane[1]
		model = Sketchup.active_model
		ents = model.active_entities
		tvecs = []
		tents = []
		Sketchup.active_model.start_operation "Throw to Plane"#Sketchup.active_model.commit_operation
		model.selection.each{|sel|
			pts = []
			pts = get_all_vt_pts( sel )
			pts2 = pts.uniq.compact
			dist = model.bounds.diagonal
			tvec = Geom::Vector3d.new(0,0,0)
			pts2.each{|pt3|
				ray = [ pt3 , vec ]
				ipt = Geom.intersect_line_plane(ray, plane)
				if ipt
					if pt3.distance( ipt ) < dist
						dist = pt3.distance( ipt )
						tvec = pt3.vector_to( ipt )
					end
				end
			}
			if tvec.valid?
				tents.push sel
				tvecs.push tvec
			end
		}
		if tents != []
			ents.transform_by_vectors tents, tvecs
		end
		Sketchup.active_model.commit_operation
	end
	def get_all_vt_pts( e , gtr = Geom::Transformation.new )
		if e.kind_of? Sketchup::Group
			tr = e.transformation
			pts = []
			e.entities.each{|e2|
				pts.push get_all_vt_pts( e2 , gtr * tr )
			}
			return pts.flatten
		elsif e.kind_of? Sketchup::ComponentInstance 
			tr = e.transformation
			pts = []
			e.definition.entities.each{|e2|
				pts.push get_all_vt_pts( e2 , gtr * tr )
			}
			return pts.flatten
		elsif e.visible? and ( e.kind_of? Sketchup::Face or e.kind_of? Sketchup::Edge )
			return e.vertices.map{|vt| vt.position.transform( gtr ) }
		end
	end
end # Class Throw_afu

# -------------------------------------------------------------------------------------------------

if( not file_loaded?("Throw_afu.rb") )
	#trow_submenu = UI.menu("Plugins").add_submenu("Throw_afu")
	#trow_submenu.add_item( "Throw To Infinity"){
	#	Sketchup.active_model.select_tool( Throw_afu.new )
	#}
	#trow_submenu.add_item( "Throw To Plane"){
#		Sketchup.active_model.select_tool( Throw_afu_face.new )
#	}
end

file_loaded("Throw_afu.rb")
